"use client";
import { FormEvent, Fragment, useEffect, useRef, useState } from "react";
import { Controller, useForm } from "react-hook-form";
import * as z from "zod";
import { zodResolver } from "@hookform/resolvers/zod";
import Swal from "sweetalert2";
import withReactContent from "sweetalert2-react-content";
import { Input, Textarea } from "@nextui-org/input";
import dynamic from "next/dynamic";
import JoditEditor from "jodit-react";
import { useDropzone } from "react-dropzone";
import { Button } from "@nextui-org/button";
import { CloudUploadIcon, TimesIcon } from "@/components/icons";
import Image from "next/image";
import { Switch } from "@nextui-org/switch";
import { createArticle, getArticleByCategory } from "@/service/article";
import ReactSelect from "react-select";
import makeAnimated from "react-select/animated";
import { Chip } from "@nextui-org/react";
import GenerateSingleArticleForm from "./generate-ai-single-form";
import { htmlToString } from "@/utils/global";
import { close, error, loading } from "@/config/swal";
import { useRouter } from "next/navigation";
import Link from "next/link";

// const CustomEditor = dynamic(
//   () => {
//     return import("@/components/editor/custom-editor");
//   },
//   { ssr: false }
// );

interface FileWithPreview extends File {
  preview: string;
}

interface CategoryType {
  id: number;
  label: string;
  value: number;
}
const categorySchema = z.object({
  id: z.number(),
  label: z.string(),
  value: z.number(),
});

const createArticleSchema = z.object({
  title: z.string().min(2, {
    message: "Judul harus diisi",
  }),
  slug: z.string().min(2, {
    message: "Slug harus diisi",
  }),
  description: z.string().min(2, {
    message: "Deskripsi harus diisi",
  }),
  category: z.array(categorySchema).nonempty({
    message: "Kategori harus memiliki setidaknya satu item",
  }),
  tags: z.array(z.string()).nonempty({
    message: "Minimal 1 tag",
  }), // Array berisi string
});

export default function CreateArticleForm() {
  const animatedComponents = makeAnimated();
  const MySwal = withReactContent(Swal);
  const router = useRouter();
  const editor = useRef(null);
  const [files, setFiles] = useState<FileWithPreview[]>([]);
  const [useAi, setUseAI] = useState(false);
  const [listCategory, setListCategory] = useState<CategoryType[]>([]);
  const [tag, setTag] = useState("");

  const { getRootProps, getInputProps } = useDropzone({
    onDrop: (acceptedFiles) => {
      setFiles(acceptedFiles.map((file) => Object.assign(file)));
    },
  });

  const formOptions = {
    resolver: zodResolver(createArticleSchema),
    defaultValues: { title: "", description: "", category: [], tags: [] },
  };
  type UserSettingSchema = z.infer<typeof createArticleSchema>;
  const {
    register,
    control,
    handleSubmit,
    formState: { errors },
    setValue,
    getValues,
    watch,
    setError,
    clearErrors,
  } = useForm<UserSettingSchema>(formOptions);

  useEffect(() => {
    fetchCategory();
  }, []);

  const fetchCategory = async () => {
    const res = await getArticleByCategory();
    if (res?.data?.data) {
      setupCategory(res?.data?.data);
    }
  };

  const setupCategory = (data: any) => {
    const temp = [];
    for (const element of data) {
      temp.push({
        id: element.id,
        label: element.title,
        value: element.id,
      });
    }
    setListCategory(temp);
  };

  const onSubmit = async (values: z.infer<typeof createArticleSchema>) => {
    MySwal.fire({
      title: "Simpan Data",
      text: "",
      icon: "warning",
      showCancelButton: true,
      cancelButtonColor: "#d33",
      confirmButtonColor: "#3085d6",
      confirmButtonText: "Simpan",
    }).then((result) => {
      if (result.isConfirmed) {
        save(values);
      }
    });
  };

  function removeImgTags(htmlString: string) {
    const parser = new DOMParser();
    const doc = parser.parseFromString(String(htmlString), "text/html");

    const images = doc.querySelectorAll("img");
    images.forEach((img) => img.remove());
    return doc.body.innerHTML;
  }

  const save = async (values: z.infer<typeof createArticleSchema>) => {
    loading();
    const formData = {
      title: values.title,
      typeId: 1,
      slug: values.slug,
      categoryId: values.category.map((item) => item.id).join(","),
      tags: values.tags.join(","),
      description: htmlToString(removeImgTags(values.description)),
      htmlDescription: removeImgTags(values.description),
    };

    const response = await createArticle(formData);

    if (response?.error) {
      error(response.message);
      return false;
    }
    close();
    successSubmit("/admin/article");
  };

  function successSubmit(redirect: string) {
    MySwal.fire({
      title: "Sukses",
      icon: "success",
      confirmButtonColor: "#3085d6",
      confirmButtonText: "OK",
    }).then((result) => {
      if (result.isConfirmed) {
        router.push(redirect);
      }
    });
  }

  const watchTitle = watch("title");
  const generateSlug = (title: string) => {
    return title
      .toLowerCase()
      .trim()
      .replace(/[^\w\s-]/g, "")
      .replace(/\s+/g, "-");
  };

  useEffect(() => {
    setValue("slug", generateSlug(watchTitle));
  }, [watchTitle]);

  const renderFilePreview = (file: FileWithPreview) => {
    if (file.type.startsWith("image")) {
      return (
        <Image
          width={48}
          height={48}
          alt={file.name}
          src={URL.createObjectURL(file)}
          className=" rounded border p-0.5"
        />
      );
    } else {
      return "Not Found";
    }
  };

  const handleRemoveFile = (file: FileWithPreview) => {
    const uploadedFiles = files;
    const filtered = uploadedFiles.filter((i) => i.name !== file.name);
    setFiles([...filtered]);
  };

  const fileList = files.map((file) => (
    <div
      key={file.name}
      className=" flex justify-between border px-3.5 py-3 my-6 rounded-md"
    >
      <div className="flex gap-3 items-center">
        <div className="file-preview">{renderFilePreview(file)}</div>
        <div>
          <div className=" text-sm  text-card-foreground">{file.name}</div>
          <div className=" text-xs font-light text-muted-foreground">
            {Math.round(file.size / 100) / 10 > 1000 ? (
              <>{(Math.round(file.size / 100) / 10000).toFixed(1)}</>
            ) : (
              <>{(Math.round(file.size / 100) / 10).toFixed(1)}</>
            )}
            {" kb"}
          </div>
        </div>
      </div>

      <Button
        className=" border-none rounded-full"
        onClick={() => handleRemoveFile(file)}
      >
        <TimesIcon />
      </Button>
    </div>
  ));

  return (
    <form
      className="flex flex-row gap-8 text-black"
      onSubmit={handleSubmit(onSubmit)}
    >
      <div className="w-[65%] bg-white rounded-lg p-8 flex flex-col gap-1">
        <p className="text-sm">Judul</p>
        <Controller
          control={control}
          name="title"
          render={({ field: { onChange, value } }) => (
            <Input
              type="text"
              id="title"
              placeholder=""
              label=""
              value={value}
              onChange={onChange}
              labelPlacement="outside"
              className="w-full "
              classNames={{
                inputWrapper: [
                  "border-1 rounded-lg",
                  "dark:group-data-[focused=false]:bg-transparent !border-1 dark:!border-gray-400",
                ],
              }}
              variant="bordered"
            />
          )}
        />
        {errors?.title && (
          <p className="text-red-400 text-sm mb-3">{errors.title?.message}</p>
        )}
        <p className="text-sm mt-3">Slug</p>
        <Controller
          control={control}
          name="slug"
          render={({ field: { onChange, value } }) => (
            <Input
              type="text"
              id="title"
              placeholder=""
              label=""
              value={value}
              isReadOnly
              onChange={onChange}
              labelPlacement="outside"
              className="w-full "
              classNames={{
                inputWrapper: [
                  "border-1 rounded-lg",
                  "dark:group-data-[focused=false]:bg-transparent !border-1 dark:!border-gray-400",
                ],
              }}
              variant="bordered"
            />
          )}
        />
        {errors?.slug && (
          <p className="text-red-400 text-sm mb-3">{errors.slug?.message}</p>
        )}

        <Switch isSelected={useAi} onValueChange={setUseAI} className="mt-3">
          <p className="text-sm text-black">Bantuan AI</p>
        </Switch>

        {useAi && (
          <GenerateSingleArticleForm
            content={(data) => setValue("description", data)}
          />
        )}

        <p className="text-sm mt-3">Deskripsi</p>
        <Controller
          control={control}
          name="description"
          render={({ field: { onChange, value } }) => (
            // <CustomEditor onChange={onChange} initialData={value} />
            <JoditEditor
              ref={editor}
              value={value}
              onChange={onChange}
              className="dark:text-black"
            />
          )}
        />
        {errors?.description && (
          <p className="text-red-400 text-sm mb-3">
            {errors.description?.message}
          </p>
        )}

        <p className="text-sm mt-3">File Media</p>
        <Fragment>
          <div {...getRootProps({ className: "dropzone" })}>
            <input {...getInputProps()} />
            <div className=" w-full text-center border-dashed border border-default-200 dark:border-default-300  rounded-md py-[52px] flex  items-center flex-col">
              <CloudUploadIcon size={50} className="text-gray-300" />
              <h4 className=" text-2xl font-medium mb-1 mt-3 text-card-foreground/80">
                Tarik file disini atau klik untuk upload.
              </h4>
              <div className=" text-xs text-muted-foreground">
                ( Upload file dengan format .jpg, .jpeg, atau .png. Ukuran
                maksimal 100mb.)
              </div>
            </div>
          </div>
          {files.length ? (
            <Fragment>
              <div>{fileList}</div>
              <div className=" flex justify-between gap-2">
                {/* <div className="flex flex-row items-center gap-3 py-3">
                  <Label>Gunakan Watermark</Label>
                  <div className="flex items-center gap-3">
                    <Switch defaultChecked color="primary" id="c2" />
                  </div>
                </div> */}
                <Button onPress={() => setFiles([])}>Remove All</Button>
              </div>
            </Fragment>
          ) : null}
        </Fragment>
      </div>
      <div className="w-[35%]  flex flex-col gap-8">
        <div className="h-fit bg-white rounded-lg p-8 flex flex-col gap-1">
          <p className="text-sm">Thubmnail</p>
          <Button className="w-fit" color="primary" size="sm">
            Upload Thumbnail
          </Button>
          <p className="text-sm mt-3">Kategori</p>
          <Controller
            control={control}
            name="category"
            render={({ field: { onChange, value } }) => (
              <ReactSelect
                className="basic-single text-black z-50"
                classNames={{
                  control: (state: any) =>
                    "!rounded-lg bg-white !border-1 !border-gray-200 dark:!border-stone-500",
                }}
                classNamePrefix="select"
                onChange={onChange}
                closeMenuOnSelect={false}
                components={animatedComponents}
                isClearable={true}
                isSearchable={true}
                isMulti={true}
                placeholder="Kategori..."
                name="sub-module"
                options={listCategory}
              />
            )}
          />
          {errors?.category && (
            <p className="text-red-400 text-sm mb-3">
              {errors.category?.message}
            </p>
          )}

          <p className="text-sm">Tags</p>
          <Controller
            control={control}
            name="tags"
            render={({ field: { onChange, value } }) => (
              <Textarea
                type="text"
                id="tags"
                placeholder=""
                label=""
                value={tag}
                onValueChange={setTag}
                startContent={
                  <div className="flex flex-wrap gap-1">
                    {value.map((item, index) => (
                      <Chip
                        color="primary"
                        key={index}
                        className=""
                        onClose={() => {
                          const filteredTags = value.filter(
                            (tag) => tag !== item
                          );
                          if (filteredTags.length === 0) {
                            setError("tags", {
                              type: "manual",
                              message: "Tags tidak boleh kosong",
                            });
                          } else {
                            // Hapus error jika sebelumnya ada dan update value
                            clearErrors("tags");
                            setValue(
                              "tags",
                              filteredTags as [string, ...string[]]
                            );
                          }
                        }}
                      >
                        {item}
                      </Chip>
                    ))}
                  </div>
                }
                onKeyDown={(e) => {
                  if (e.key === "Enter") {
                    if (tag.trim() !== "") {
                      setValue("tags", [...value, tag.trim()]);
                      setTag("");
                      e.preventDefault();
                    }
                  }
                }}
                labelPlacement="outside"
                className="w-full h-fit"
                classNames={{
                  inputWrapper: [
                    "border-1 rounded-lg",
                    "dark:group-data-[focused=false]:bg-transparent !border-1 dark:!border-gray-400",
                  ],
                }}
                variant="bordered"
              />
            )}
          />
          {errors?.tags && (
            <p className="text-red-400 text-sm  mb-3">{errors.tags?.message}</p>
          )}
        </div>
        <div className="flex flex-row justify-end gap-3">
          <Button color="primary" type="submit">
            Publish
          </Button>
          <Button color="success" type="button">
            <p className="text-white">Draft</p>
          </Button>
          <Link href="/admin/article">
            <Button color="danger" variant="bordered" type="button">
              Kembali
            </Button>
          </Link>
        </div>
      </div>
    </form>
  );
}
